## golang-github-apache-arrow-go 18.1.0

=== debian/changelog ===
golang-github-apache-arrow-go (18.1.0-2) unstable; urgency=medium

  * Standards-Version: 4.7.2.
  * Build on more archs on Salsa.
  * Add upstream 32-bit arch fix.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 05 Mar 2025 20:25:35 +0100

golang-github-apache-arrow-go (18.1.0-1) unstable; urgency=medium

  * Initial release (Closes: #1095753)

 -- Simon Josefsson <simon@josefsson.org>  Tue, 11 Feb 2025 17:57:29 +0100

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/apache/arrow-go/tags .*/v?(\d\S*)\.tar\.gz debian

## golang-github-apache-arrow-go 18.2.0

=== internal/utils/Makefile ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# this converts rotate instructions from "ro[lr] <reg>" -> "ro[lr] <reg>, 1" for yasm compatibility
PERL_FIXUP_ROTATE=perl -i -pe 's/(ro[rl]\s+\w{2,3})$$/\1, 1/'

C2GOASM=c2goasm
CC=clang-11
C_FLAGS=-target x86_64-unknown-none -masm=intel -mno-red-zone -mstackrealign -mllvm -inline-threshold=1000 \
				-fno-asynchronous-unwind-tables -fno-exceptions -fno-rtti -O3 -fno-builtin -ffast-math -fno-jump-tables -I_lib
ASM_FLAGS_AVX2=-mavx2 -mfma
ASM_FLAGS_SSE4=-msse4
ASM_FLAGS_BMI2=-mbmi2
ASM_FLAGS_POPCNT=-mpopcnt

C_FLAGS_NEON=-O3 -fvectorize -mllvm -force-vector-width=16 -fno-asynchronous-unwind-tables -mno-red-zone -mstackrealign -fno-exceptions \
	-fno-rtti -fno-builtin -ffast-math -fno-jump-tables -I_lib

GO_SOURCES  := $(shell find . -path ./_lib -prune -o -name '*.go' -not -name '*_test.go')
ALL_SOURCES := $(shell find . -path ./_lib -prune -o -name '*.go' -name '*.s' -not -name '*_test.go')

.PHONEY: assembly

INTEL_SOURCES := \
	min_max_avx2_amd64.s min_max_sse4_amd64.s transpose_ints_avx2_amd64.s transpose_ints_sse4_amd64.s

#
# ARROW-15336: DO NOT add the assembly target for Arm64 (ARM_SOURCES) until c2goasm added the Arm64 support.
# min_max_neon_arm64.s was generated by asm2plan9s.
# And manually formatted it as the Arm64 Plan9.
#

assembly: $(INTEL_SOURCES)

_lib/min_max_avx2_amd64.s: _lib/min_max.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/min_max_sse4_amd64.s: _lib/min_max.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/min_max_neon.s: _lib/min_max.c
	$(CC) -S $(C_FLAGS_NEON) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/transpose_ints_avx2_amd64.s: _lib/transpose_ints.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/transpose_ints_sse4_amd64.s: _lib/transpose_ints.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/transpose_ints_neon.s: _lib/transpose_ints.c
	$(CC) -S $(C_FLAGS_NEON) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

min_max_avx2_amd64.s: _lib/min_max_avx2_amd64.s
	$(C2GOASM) -a -f $^ $@

min_max_sse4_amd64.s: _lib/min_max_sse4_amd64.s
	$(C2GOASM) -a -f $^ $@

transpose_ints_avx2_amd64.s: _lib/transpose_ints_avx2_amd64.s
	$(C2GOASM) -a -f $^ $@

transpose_ints_sse4_amd64.s: _lib/transpose_ints_sse4_amd64.s
	$(C2GOASM) -a -f $^ $@

clean:
	rm -f $(INTEL_SOURCES)
	rm -f $(addprefix _lib/,$(INTEL_SOURCES))

=== arrow/memory/_lib/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.6)

project(memory-func)
set(CMAKE_C_STANDARD 99)

add_library(memory STATIC memory.c)

=== parquet/internal/utils/Makefile ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# this converts rotate instructions from "ro[lr] <reg>" -> "ro[lr] <reg>, 1" for yasm compatibility
PERL_FIXUP_ROTATE=perl -i -pe 's/(ro[rl]\s+\w{2,3})$$/\1, 1/'

C2GOASM=c2goasm
CC=clang-11
C_FLAGS=-target x86_64-unknown-none -masm=intel -mno-red-zone -mstackrealign -mllvm -inline-threshold=1000 \
				-fno-asynchronous-unwind-tables -fno-exceptions -fno-rtti -O3 -fno-builtin -ffast-math -fno-jump-tables -I_lib
ASM_FLAGS_AVX2=-mavx2 -mfma
ASM_FLAGS_SSE4=-msse4
ASM_FLAGS_BMI2=-mbmi2
ASM_FLAGS_POPCNT=-mpopcnt

C_FLAGS_NEON=-O3 -fvectorize -mllvm -force-vector-width=16 -fno-asynchronous-unwind-tables -mno-red-zone -mstackrealign -fno-exceptions \
	-fno-rtti -fno-builtin -ffast-math -fno-jump-tables -I_lib

GO_SOURCES  := $(shell find . -path ./_lib -prune -o -name '*.go' -not -name '*_test.go')
ALL_SOURCES := $(shell find . -path ./_lib -prune -o -name '*.go' -name '*.s' -not -name '*_test.go')

.PHONY: assembly

INTEL_SOURCES := \
	bit_packing_avx2_amd64.s \
	unpack_bool_avx2_amd64.s unpack_bool_sse4_amd64.s

ARM_SOURCES := \
	bit_packing_neon_arm64.s unpack_bool_neon_arm64.s

#
# ARROW-15336: DO NOT add the assembly target for Arm64 (ARM_SOURCES) until c2goasm added the Arm64 support.
# min_max_neon_arm64.s was generated by asm2plan9s.
# And manually formatted it as the Arm64 Plan9.
#

assembly: $(INTEL_SOURCES)

_lib/bit_packing_avx2.s: _lib/bit_packing_avx2.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@; perl -i -pe 's/mem(cpy|set)/clib·_mem\1(SB)/' $@

_lib/unpack_bool_avx2.s: _lib/unpack_bool.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/unpack_bool_sse4.s: _lib/unpack_bool.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/unpack_bool_neon.s: _lib/unpack_bool.c
	$(CC) -S $(C_FLAGS_NEON) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/bit_packing_neon.s: _lib/bit_packing_neon.c
	$(CC) -S $(C_FLAGS_NEON) $^ -o $@

bit_packing_avx2_amd64.s: _lib/bit_packing_avx2.s
	$(C2GOASM) -a -f $^ $@

unpack_bool_avx2_amd64.s: _lib/unpack_bool_avx2.s
	$(C2GOASM) -a -f $^ $@

unpack_bool_sse4_amd64.s: _lib/unpack_bool_sse4.s
	$(C2GOASM) -a -f $^ $@

clean:
	rm -f $(INTEL_SOURCES)
	rm -f $(addprefix _lib/,$(INTEL_SOURCES))

=== arrow/compute/internal/kernels/Makefile ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# this converts rotate instructions from "ro[lr] <reg>" -> "ro[lr] <reg>, 1" for yasm compatibility
PERL_FIXUP_ROTATE=perl -i -pe 's/(ro[rl]\s+\w{2,3})$$/\1, 1/'

C2GOASM=c2goasm
CC=clang-11
CXX=clang++-11
C_FLAGS=-target x86_64-unknown-none -masm=intel -mno-red-zone -mstackrealign -mllvm -inline-threshold=5000 \
				-fno-asynchronous-unwind-tables -fno-exceptions -fno-rtti -O3 -fno-builtin -fno-jump-tables \
				-fno-math-errno -funsafe-math-optimizations -fno-rounding-math -fno-trapping-math -I_lib -I../../../../internal/utils/_lib
ASM_FLAGS_AVX2=-mavx2 -mfma
ASM_FLAGS_SSE4=-msse4
ASM_FLAGS_BMI2=-mbmi2
ASM_FLAGS_POPCNT=-mpopcnt

C_FLAGS_NEON=-O3 -fvectorize -mllvm -force-vector-width=16 -fno-asynchronous-unwind-tables -mno-red-zone -mstackrealign -fno-exceptions \
	-fno-rtti -fno-builtin -fno-math-errno -funsafe-math-optimizations -fno-rounding-math -fno-trapping-math -fno-jump-tables -I_lib -I../../../../internal/utils/_lib

GO_SOURCES  := $(shell find . -path ./_lib -prune -o -name '*.go' -not -name '*_test.go')
ALL_SOURCES := $(shell find . -path ./_lib -prune -o -name '*.go' -name '*.s' -not -name '*_test.go')

.PHONEY: assembly

INTEL_SOURCES := \
	cast_numeric_avx2_amd64.s cast_numeric_sse4_amd64.s constant_factor_avx2_amd64.s \
	constant_factor_sse4_amd64.s base_arithmetic_avx2_amd64.s base_arithmetic_sse4_amd64.s \
	scalar_comparison_avx2_amd64.s scalar_comparison_sse4_amd64.s

#
# ARROW-15336: DO NOT add the assembly target for Arm64 (ARM_SOURCES) until c2goasm added the Arm64 support.
# min_max_neon_arm64.s was generated by asm2plan9s.
# And manually formatted it as the Arm64 Plan9.
#

assembly: $(INTEL_SOURCES)

_lib/cast_numeric_avx2_amd64.s: _lib/cast_numeric.cc
	$(CXX) -std=c++17 -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@	

_lib/cast_numeric_sse4_amd64.s: _lib/cast_numeric.cc
	$(CXX) -std=c++17 -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/cast_numeric_neon.s: _lib/cast_numeric.cc
	$(CXX) -std=c++17 -S $(C_FLAGS_NEON) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/base_arithmetic_avx2_amd64.s: _lib/base_arithmetic.cc
	$(CXX) -std=c++17 -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/base_arithmetic_sse4_amd64.s: _lib/base_arithmetic.cc
	$(CXX) -std=c++17 -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/scalar_comparison_avx2_amd64.s: _lib/scalar_comparison.cc
	$(CXX) -std=c++17 -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@	

_lib/scalar_comparison_sse4_amd64.s: _lib/scalar_comparison.cc
	$(CXX) -std=c++17 -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/base_arithmetic_neon.s: _lib/base_arithmetic.cc
	$(CXX) -std=c++17 -S $(C_FLAGS_NEON) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/constant_factor_avx2_amd64.s: _lib/constant_factor.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_AVX2) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/constant_factor_sse4_amd64.s: _lib/constant_factor.c
	$(CC) -S $(C_FLAGS) $(ASM_FLAGS_SSE4) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

_lib/constant_factor_neon.s: _lib/constant_factor.c
	$(CC) -S $(C_FLAGS_NEON) $^ -o $@ ; $(PERL_FIXUP_ROTATE) $@

cast_numeric_avx2_amd64.s: _lib/cast_numeric_avx2_amd64.s
	$(C2GOASM) -a -f $^ $@

cast_numeric_sse4_amd64.s: _lib/cast_numeric_sse4_amd64.s
	$(C2GOASM) -a -f $^ $@

constant_factor_avx2_amd64.s: _lib/constant_factor_avx2_amd64.s
	$(C2GOASM) -a -f $^ $@

constant_factor_sse4_amd64.s: _lib/constant_factor_sse4_amd64.s
	$(C2GOASM) -a -f $^ $@

base_arithmetic_avx2_amd64.s: _lib/base_arithmetic_avx2_amd64.s
	$(C2GOASM) -a -f $^ $@

base_arithmetic_sse4_amd64.s: _lib/base_arithmetic_sse4_amd64.s
	$(C2GOASM) -a -f $^ $@

scalar_comparison_avx2_amd64.s: _lib/scalar_comparison_avx2_amd64.s	
	$(C2GOASM) -a -f $^ $@

scalar_comparison_sse4_amd64.s: _lib/scalar_comparison_sse4_amd64.s
	$(C2GOASM) -a -f $^ $@

clean:
	rm -f $(INTEL_SOURCES)
	rm -f $(addprefix _lib/,$(INTEL_SOURCES))

=== debian/changelog ===
golang-github-apache-arrow-go (18.2.0-1) unstable; urgency=medium

  * d/salsa-ci: Build rdeps.
  * New upstream version 18.2.0
  * Drop upstreamed patch.
  * d/copyright: Drop safe-math.h special (gone upstream).
  * docs: Add NOTICE.txt.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 10 Apr 2025 02:11:43 +0200

=== debian/control ===
Source: golang-github-apache-arrow-go
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-google-flatbuffers-dev,
 golang-github-stretchr-testify-dev,
 golang-golang-x-exp-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-xerrors-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-apache-arrow-go
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-apache-arrow-go.git
Homepage: https://github.com/apache/arrow-go
XS-Go-Import-Path: github.com/apache/arrow-go/v18

Package: golang-github-apache-arrow-go-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: toolbox for data interchange and in-memory analytics (Go library)
 Apache Arrow (https://arrow.apache.org) is a cross-language development
 platform for in-memory data. It specifies a standardized language-
 independent columnar memory format for flat and hierarchical data,
 organized for efficient analytic operations on modern hardware. It also
 provides computational libraries and zero-copy streaming messaging and
 inter-process communication.
 .
 This package contains the Go development library.

=== debian/rules ===
#!/usr/bin/make -f

# strip down this package to suite golang-github-gorgonia-tensor,
# since this package needs a lot of unpackaged build dependencies
export DH_GOLANG_BUILDPKG := \
	github.com/apache/arrow-go/v18/arrow/bitutil \
	github.com/apache/arrow-go/v18/arrow/endian \
	github.com/apache/arrow-go/v18/arrow/internal/debug \
	github.com/apache/arrow-go/v18/arrow/memory

%:
	dh $@ --builddirectory=_build --buildsystem=golang
